{-# OPTIONS_GHC -Wall #-}
{-# Language ForeignFunctionInterface #-}

module Casadi.Wrappers.Deleters where

import Foreign.C.Types
import Foreign.Ptr ( FunPtr, Ptr )

import Casadi.Wrappers.Data
import Casadi.MarshalTypes

foreign import ccall unsafe "&delete_std__vector_int_" 
  c_delete_std__vector_int_ :: FunPtr (Ptr (CppVec CInt) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_int__" 
  c_delete_std__vector_std__vector_int__ :: FunPtr (Ptr (CppVecVec CInt) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_int___" 
  c_delete_std__vector_std__vector_std__vector_int___ :: FunPtr (Ptr (CppVecVecVec CInt) -> IO ())

foreign import ccall unsafe "&delete_std__vector_double_" 
  c_delete_std__vector_double_ :: FunPtr (Ptr (CppVec CDouble) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_double__" 
  c_delete_std__vector_std__vector_double__ :: FunPtr (Ptr (CppVecVec CDouble) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_double___" 
  c_delete_std__vector_std__vector_std__vector_double___ :: FunPtr (Ptr (CppVecVecVec CDouble) -> IO ())

foreign import ccall unsafe "&delete_std__string" 
  c_delete_std__string :: FunPtr (Ptr StdString' -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__string_" 
  c_delete_std__vector_std__string_ :: FunPtr (Ptr (CppVec (Ptr StdString')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__string__" 
  c_delete_std__vector_std__vector_std__string__ :: FunPtr (Ptr (CppVecVec (Ptr StdString')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_std__string___" 
  c_delete_std__vector_std__vector_std__vector_std__string___ :: FunPtr (Ptr (CppVecVecVec (Ptr StdString')) -> IO ())

foreign import ccall unsafe "&delete_bool" 
  c_delete_bool :: FunPtr (Ptr CppBool' -> IO ())
foreign import ccall unsafe "&delete_std__vector_bool_" 
  c_delete_std__vector_bool_ :: FunPtr (Ptr (CppVec (Ptr CppBool')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_bool__" 
  c_delete_std__vector_std__vector_bool__ :: FunPtr (Ptr (CppVecVec (Ptr CppBool')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_bool___" 
  c_delete_std__vector_std__vector_std__vector_bool___ :: FunPtr (Ptr (CppVecVecVec (Ptr CppBool')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__SXFunction" 
  c_delete_CasADi__SXFunction :: FunPtr (Ptr SXFunction' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__SXFunction_" 
  c_delete_std__vector_CasADi__SXFunction_ :: FunPtr (Ptr (CppVec (Ptr SXFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__SXFunction__" 
  c_delete_std__vector_std__vector_CasADi__SXFunction__ :: FunPtr (Ptr (CppVecVec (Ptr SXFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__SXFunction___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__SXFunction___ :: FunPtr (Ptr (CppVecVecVec (Ptr SXFunction')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__MXFunction" 
  c_delete_CasADi__MXFunction :: FunPtr (Ptr MXFunction' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__MXFunction_" 
  c_delete_std__vector_CasADi__MXFunction_ :: FunPtr (Ptr (CppVec (Ptr MXFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__MXFunction__" 
  c_delete_std__vector_std__vector_CasADi__MXFunction__ :: FunPtr (Ptr (CppVecVec (Ptr MXFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__MXFunction___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__MXFunction___ :: FunPtr (Ptr (CppVecVecVec (Ptr MXFunction')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__FX" 
  c_delete_CasADi__FX :: FunPtr (Ptr FX' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__FX_" 
  c_delete_std__vector_CasADi__FX_ :: FunPtr (Ptr (CppVec (Ptr FX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__FX__" 
  c_delete_std__vector_std__vector_CasADi__FX__ :: FunPtr (Ptr (CppVecVec (Ptr FX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__FX___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__FX___ :: FunPtr (Ptr (CppVecVecVec (Ptr FX')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__SharedObject" 
  c_delete_CasADi__SharedObject :: FunPtr (Ptr SharedObject' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__SharedObject_" 
  c_delete_std__vector_CasADi__SharedObject_ :: FunPtr (Ptr (CppVec (Ptr SharedObject')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__SharedObject__" 
  c_delete_std__vector_std__vector_CasADi__SharedObject__ :: FunPtr (Ptr (CppVecVec (Ptr SharedObject')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__SharedObject___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__SharedObject___ :: FunPtr (Ptr (CppVecVecVec (Ptr SharedObject')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__PrintableObject" 
  c_delete_CasADi__PrintableObject :: FunPtr (Ptr PrintableObject' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__PrintableObject_" 
  c_delete_std__vector_CasADi__PrintableObject_ :: FunPtr (Ptr (CppVec (Ptr PrintableObject')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__PrintableObject__" 
  c_delete_std__vector_std__vector_CasADi__PrintableObject__ :: FunPtr (Ptr (CppVecVec (Ptr PrintableObject')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__PrintableObject___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__PrintableObject___ :: FunPtr (Ptr (CppVecVecVec (Ptr PrintableObject')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__CRSSparsity" 
  c_delete_CasADi__CRSSparsity :: FunPtr (Ptr CRSSparsity' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__CRSSparsity_" 
  c_delete_std__vector_CasADi__CRSSparsity_ :: FunPtr (Ptr (CppVec (Ptr CRSSparsity')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__CRSSparsity__" 
  c_delete_std__vector_std__vector_CasADi__CRSSparsity__ :: FunPtr (Ptr (CppVecVec (Ptr CRSSparsity')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__CRSSparsity___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__CRSSparsity___ :: FunPtr (Ptr (CppVecVecVec (Ptr CRSSparsity')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__GenericType" 
  c_delete_CasADi__GenericType :: FunPtr (Ptr GenericType' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__GenericType_" 
  c_delete_std__vector_CasADi__GenericType_ :: FunPtr (Ptr (CppVec (Ptr GenericType')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__GenericType__" 
  c_delete_std__vector_std__vector_CasADi__GenericType__ :: FunPtr (Ptr (CppVecVec (Ptr GenericType')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__GenericType___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__GenericType___ :: FunPtr (Ptr (CppVecVecVec (Ptr GenericType')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__IOInterface_CasADi__FX_" 
  c_delete_CasADi__IOInterface_CasADi__FX_ :: FunPtr (Ptr IOInterfaceFX' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__IOInterface_CasADi__FX__" 
  c_delete_std__vector_CasADi__IOInterface_CasADi__FX__ :: FunPtr (Ptr (CppVec (Ptr IOInterfaceFX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__IOInterface_CasADi__FX___" 
  c_delete_std__vector_std__vector_CasADi__IOInterface_CasADi__FX___ :: FunPtr (Ptr (CppVecVec (Ptr IOInterfaceFX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__IOInterface_CasADi__FX____" 
  c_delete_std__vector_std__vector_std__vector_CasADi__IOInterface_CasADi__FX____ :: FunPtr (Ptr (CppVecVecVec (Ptr IOInterfaceFX')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__OptionsFunctionality" 
  c_delete_CasADi__OptionsFunctionality :: FunPtr (Ptr OptionsFunctionality' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__OptionsFunctionality_" 
  c_delete_std__vector_CasADi__OptionsFunctionality_ :: FunPtr (Ptr (CppVec (Ptr OptionsFunctionality')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__OptionsFunctionality__" 
  c_delete_std__vector_std__vector_CasADi__OptionsFunctionality__ :: FunPtr (Ptr (CppVecVec (Ptr OptionsFunctionality')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__OptionsFunctionality___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__OptionsFunctionality___ :: FunPtr (Ptr (CppVecVecVec (Ptr OptionsFunctionality')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__IpoptSolver" 
  c_delete_CasADi__IpoptSolver :: FunPtr (Ptr IpoptSolver' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__IpoptSolver_" 
  c_delete_std__vector_CasADi__IpoptSolver_ :: FunPtr (Ptr (CppVec (Ptr IpoptSolver')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__IpoptSolver__" 
  c_delete_std__vector_std__vector_CasADi__IpoptSolver__ :: FunPtr (Ptr (CppVecVec (Ptr IpoptSolver')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__IpoptSolver___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__IpoptSolver___ :: FunPtr (Ptr (CppVecVecVec (Ptr IpoptSolver')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__Matrix_CasADi__SX_" 
  c_delete_CasADi__Matrix_CasADi__SX_ :: FunPtr (Ptr SXMatrix' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__Matrix_CasADi__SX__" 
  c_delete_std__vector_CasADi__Matrix_CasADi__SX__ :: FunPtr (Ptr (CppVec (Ptr SXMatrix')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__Matrix_CasADi__SX___" 
  c_delete_std__vector_std__vector_CasADi__Matrix_CasADi__SX___ :: FunPtr (Ptr (CppVecVec (Ptr SXMatrix')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__Matrix_CasADi__SX____" 
  c_delete_std__vector_std__vector_std__vector_CasADi__Matrix_CasADi__SX____ :: FunPtr (Ptr (CppVecVecVec (Ptr SXMatrix')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__IOScheme" 
  c_delete_CasADi__IOScheme :: FunPtr (Ptr IOScheme' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__IOScheme_" 
  c_delete_std__vector_CasADi__IOScheme_ :: FunPtr (Ptr (CppVec (Ptr IOScheme')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__IOScheme__" 
  c_delete_std__vector_std__vector_CasADi__IOScheme__ :: FunPtr (Ptr (CppVecVec (Ptr IOScheme')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__IOScheme___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__IOScheme___ :: FunPtr (Ptr (CppVecVecVec (Ptr IOScheme')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__Matrix_double_" 
  c_delete_CasADi__Matrix_double_ :: FunPtr (Ptr DMatrix' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__Matrix_double__" 
  c_delete_std__vector_CasADi__Matrix_double__ :: FunPtr (Ptr (CppVec (Ptr DMatrix')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__Matrix_double___" 
  c_delete_std__vector_std__vector_CasADi__Matrix_double___ :: FunPtr (Ptr (CppVecVec (Ptr DMatrix')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__Matrix_double____" 
  c_delete_std__vector_std__vector_std__vector_CasADi__Matrix_double____ :: FunPtr (Ptr (CppVecVecVec (Ptr DMatrix')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__MX" 
  c_delete_CasADi__MX :: FunPtr (Ptr MX' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__MX_" 
  c_delete_std__vector_CasADi__MX_ :: FunPtr (Ptr (CppVec (Ptr MX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__MX__" 
  c_delete_std__vector_std__vector_CasADi__MX__ :: FunPtr (Ptr (CppVecVec (Ptr MX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__MX___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__MX___ :: FunPtr (Ptr (CppVecVecVec (Ptr MX')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__CasadiOptions" 
  c_delete_CasADi__CasadiOptions :: FunPtr (Ptr CasadiOptions' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__CasadiOptions_" 
  c_delete_std__vector_CasADi__CasadiOptions_ :: FunPtr (Ptr (CppVec (Ptr CasadiOptions')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__CasadiOptions__" 
  c_delete_std__vector_std__vector_CasADi__CasadiOptions__ :: FunPtr (Ptr (CppVecVec (Ptr CasadiOptions')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__CasadiOptions___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__CasadiOptions___ :: FunPtr (Ptr (CppVecVecVec (Ptr CasadiOptions')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__Callback" 
  c_delete_CasADi__Callback :: FunPtr (Ptr Callback' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__Callback_" 
  c_delete_std__vector_CasADi__Callback_ :: FunPtr (Ptr (CppVec (Ptr Callback')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__Callback__" 
  c_delete_std__vector_std__vector_CasADi__Callback__ :: FunPtr (Ptr (CppVecVec (Ptr Callback')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__Callback___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__Callback___ :: FunPtr (Ptr (CppVecVecVec (Ptr Callback')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__CustomEvaluate" 
  c_delete_CasADi__CustomEvaluate :: FunPtr (Ptr CustomEvaluate' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__CustomEvaluate_" 
  c_delete_std__vector_CasADi__CustomEvaluate_ :: FunPtr (Ptr (CppVec (Ptr CustomEvaluate')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__CustomEvaluate__" 
  c_delete_std__vector_std__vector_CasADi__CustomEvaluate__ :: FunPtr (Ptr (CppVecVec (Ptr CustomEvaluate')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__CustomEvaluate___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__CustomEvaluate___ :: FunPtr (Ptr (CppVecVecVec (Ptr CustomEvaluate')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__ExternalFunction" 
  c_delete_CasADi__ExternalFunction :: FunPtr (Ptr ExternalFunction' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__ExternalFunction_" 
  c_delete_std__vector_CasADi__ExternalFunction_ :: FunPtr (Ptr (CppVec (Ptr ExternalFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__ExternalFunction__" 
  c_delete_std__vector_std__vector_CasADi__ExternalFunction__ :: FunPtr (Ptr (CppVecVec (Ptr ExternalFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__ExternalFunction___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__ExternalFunction___ :: FunPtr (Ptr (CppVecVecVec (Ptr ExternalFunction')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__CSparse" 
  c_delete_CasADi__CSparse :: FunPtr (Ptr CSparse' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__CSparse_" 
  c_delete_std__vector_CasADi__CSparse_ :: FunPtr (Ptr (CppVec (Ptr CSparse')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__CSparse__" 
  c_delete_std__vector_std__vector_CasADi__CSparse__ :: FunPtr (Ptr (CppVecVec (Ptr CSparse')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__CSparse___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__CSparse___ :: FunPtr (Ptr (CppVecVecVec (Ptr CSparse')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__SX" 
  c_delete_CasADi__SX :: FunPtr (Ptr SX' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__SX_" 
  c_delete_std__vector_CasADi__SX_ :: FunPtr (Ptr (CppVec (Ptr SX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__SX__" 
  c_delete_std__vector_std__vector_CasADi__SX__ :: FunPtr (Ptr (CppVecVec (Ptr SX')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__SX___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__SX___ :: FunPtr (Ptr (CppVecVecVec (Ptr SX')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__CasadiMeta" 
  c_delete_CasADi__CasadiMeta :: FunPtr (Ptr CasadiMeta' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__CasadiMeta_" 
  c_delete_std__vector_CasADi__CasadiMeta_ :: FunPtr (Ptr (CppVec (Ptr CasadiMeta')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__CasadiMeta__" 
  c_delete_std__vector_std__vector_CasADi__CasadiMeta__ :: FunPtr (Ptr (CppVecVec (Ptr CasadiMeta')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__CasadiMeta___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__CasadiMeta___ :: FunPtr (Ptr (CppVecVecVec (Ptr CasadiMeta')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__Functor" 
  c_delete_CasADi__Functor :: FunPtr (Ptr Functor' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__Functor_" 
  c_delete_std__vector_CasADi__Functor_ :: FunPtr (Ptr (CppVec (Ptr Functor')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__Functor__" 
  c_delete_std__vector_std__vector_CasADi__Functor__ :: FunPtr (Ptr (CppVecVec (Ptr Functor')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__Functor___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__Functor___ :: FunPtr (Ptr (CppVecVecVec (Ptr Functor')) -> IO ())

foreign import ccall unsafe "&delete_CasADi__CustomFunction" 
  c_delete_CasADi__CustomFunction :: FunPtr (Ptr CustomFunction' -> IO ())
foreign import ccall unsafe "&delete_std__vector_CasADi__CustomFunction_" 
  c_delete_std__vector_CasADi__CustomFunction_ :: FunPtr (Ptr (CppVec (Ptr CustomFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_CasADi__CustomFunction__" 
  c_delete_std__vector_std__vector_CasADi__CustomFunction__ :: FunPtr (Ptr (CppVecVec (Ptr CustomFunction')) -> IO ())
foreign import ccall unsafe "&delete_std__vector_std__vector_std__vector_CasADi__CustomFunction___" 
  c_delete_std__vector_std__vector_std__vector_CasADi__CustomFunction___ :: FunPtr (Ptr (CppVecVecVec (Ptr CustomFunction')) -> IO ())
