{-# OPTIONS_GHC -Wall #-}
{-# Language ForeignFunctionInterface #-}

module Casadi.Wrappers.ForeignToolsImports where

import Foreign.C.Types
import Foreign.Ptr ( Ptr )

import Casadi.MarshalTypes

--------------------------- ("int","CInt",Nothing,["Int"]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_int" c_newVecCInt
  :: Ptr CInt -> CInt -> IO (Ptr (CppVec CInt))
foreign import ccall unsafe "hs_delete_vec_int" c_deleteVecCInt
  :: Ptr (CppVec CInt) -> IO ()
foreign import ccall unsafe "hs_new_vec_vec_int" c_newVecVecCInt
  :: Ptr CInt -> CInt -> Ptr CInt -> IO (Ptr (CppVecVec CInt))
foreign import ccall unsafe "hs_delete_vec_vec_int" c_deleteVecVecCInt
  :: Ptr (CppVecVec CInt) -> IO ()

--------------------------- ("voidp","VoidP",Just "(Ptr a)",[]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_voidp" c_newVecVoidP
  :: Ptr (Ptr a) -> CInt -> IO (Ptr (CppVec (Ptr a)))
foreign import ccall unsafe "hs_delete_vec_voidp" c_deleteVecVoidP
  :: Ptr (CppVec (Ptr a)) -> IO ()
foreign import ccall unsafe "hs_new_vec_vec_voidp" c_newVecVecVoidP
  :: Ptr (Ptr a) -> CInt -> Ptr CInt -> IO (Ptr (CppVecVec (Ptr a)))
foreign import ccall unsafe "hs_delete_vec_vec_voidp" c_deleteVecVecVoidP
  :: Ptr (CppVecVec (Ptr a)) -> IO ()

--------------------------- ("uchar","CUChar",Nothing,[]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_uchar" c_newVecCUChar
  :: Ptr CUChar -> CInt -> IO (Ptr (CppVec CUChar))
foreign import ccall unsafe "hs_delete_vec_uchar" c_deleteVecCUChar
  :: Ptr (CppVec CUChar) -> IO ()
foreign import ccall unsafe "hs_new_vec_vec_uchar" c_newVecVecCUChar
  :: Ptr CUChar -> CInt -> Ptr CInt -> IO (Ptr (CppVecVec CUChar))
foreign import ccall unsafe "hs_delete_vec_vec_uchar" c_deleteVecVecCUChar
  :: Ptr (CppVecVec CUChar) -> IO ()

--------------------------- ("double","CDouble",Nothing,["Double"]) -----------------------------------
foreign import ccall unsafe "hs_new_vec_double" c_newVecCDouble
  :: Ptr CDouble -> CInt -> IO (Ptr (CppVec CDouble))
foreign import ccall unsafe "hs_delete_vec_double" c_deleteVecCDouble
  :: Ptr (CppVec CDouble) -> IO ()
foreign import ccall unsafe "hs_new_vec_vec_double" c_newVecVecCDouble
  :: Ptr CDouble -> CInt -> Ptr CInt -> IO (Ptr (CppVecVec CDouble))
foreign import ccall unsafe "hs_delete_vec_vec_double" c_deleteVecVecCDouble
  :: Ptr (CppVecVec CDouble) -> IO ()
